package com.biganto.visual.roompark.presentation.screen.auth

import com.biganto.visual.roompark.conductor.BigantoBasePresenter
import com.biganto.visual.roompark.domain.interactor.AuthInteractor
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


class AuthScreenPresenter @Inject constructor(
    private val interactor: AuthInteractor
)
    : BigantoBasePresenter<AuthScreen, AuthScreenViewState>() {


    override fun bindIntents() {

        val onAuth = intent(AuthScreen::tryAuth)
            .flatMap { interactor.getAuth() }



        val state = restoreStateObservable
            .mergeWith(interactor.getAuth()
                .map { AuthScreenViewState.ToScreen(it.toString()) })
        subscribeViewState(state.cast(AuthScreenViewState::class.java), AuthScreen::render)
    }

}